<!--
Copyright (C) 2005 - 2021 Settlers Freaks <sf-team at siedler25.org>

SPDX-License-Identifier: GPL-2.0-or-later
-->

# Constants

These are the named constants that must be used to refer to specific instances.
They are also used when an event is called.

- [Wares / Goods](#Wares-/-Goods)  
- [Buildings](#Buildings)  
- [Jobs](#Jobs)  
- [Resources](#Resources)  
- [Animals](#Animals)  
- [Pacts](#Pacts)  

## Wares / Goods

--> [gameTypes/GoodTypes.h](../../libs/s25main/gameTypes/GoodTypes.h)  
GD_BEER  
GD_TONGS  
GD_HAMMER  
GD_AXE  
GD_SAW  
GD_PICKAXE  
GD_SHOVEL  
GD_CRUCIBLE  
GD_RODANDLINE  
GD_SCYTHE  
GD_WATER  
GD_CLEAVER  
GD_ROLLINGPIN  
GD_BOW  
GD_BOAT  
GD_SWORD  
GD_IRON  
GD_FLOUR  
GD_FISH  
GD_BREAD  
GD_SHIELD  
GD_WOOD  
GD_BOARDS  
GD_STONES  
GD_GRAIN  
GD_COINS  
GD_GOLD  
GD_IRONORE  
GD_COAL  
GD_MEAT  
GD_HAM  

## Buildings

--> [gameTypes/BuildingType.h](../../libs/s25main/gameTypes/BuildingType.h)  
BLD_HEADQUARTERS  
BLD_BARRACKS  
BLD_GUARDHOUSE  
BLD_WATCHTOWER  
BLD_FORTRESS  
BLD_GRANITEMINE  
BLD_COALMINE  
BLD_IRONMINE  
BLD_GOLDMINE  
BLD_LOOKOUTTOWER  
BLD_CATAPULT  
BLD_WOODCUTTER  
BLD_FISHERY  
BLD_QUARRY  
BLD_FORESTER  
BLD_SLAUGHTERHOUSE  
BLD_HUNTER  
BLD_BREWERY  
BLD_ARMORY  
BLD_METALWORKS  
BLD_IRONSMELTER  
BLD_CHARBURNER  
BLD_PIGFARM  
BLD_STOREHOUSE  
BLD_MILL  
BLD_BAKERY  
BLD_SAWMILL  
BLD_MINT  
BLD_WELL  
BLD_SHIPYARD  
BLD_FARM  
BLD_DONKEYBREEDER  
BLD_HARBORBUILDING  

## Jobs

--> [gameTypes/JobTypes.h](../../libs/s25main/gameTypes/JobTypes.h)  
JOB_HELPER  
JOB_WOODCUTTER  
JOB_FISHER  
JOB_FORESTER  
JOB_CARPENTER  
JOB_STONEMASON  
JOB_HUNTER  
JOB_FARMER  
JOB_MILLER  
JOB_BAKER  
JOB_BUTCHER  
JOB_MINER  
JOB_BREWER  
JOB_PIGBREEDER  
JOB_DONKEYBREEDER  
JOB_IRONFOUNDER  
JOB_MINTER  
JOB_METALWORKER  
JOB_ARMORER  
JOB_BUILDER  
JOB_PLANER  
JOB_PRIVATE  
JOB_PRIVATEFIRSTCLASS  
JOB_SERGEANT  
JOB_OFFICER  
JOB_GENERAL  
JOB_GEOLOGIST  
JOB_SHIPWRIGHT  
JOB_SCOUT  
JOB_PACKDONKEY  
JOB_BOATCARRIER  
JOB_CHARBURNER

## Resources

--> [lua/LuaInterfaceGame.cpp](../../libs/s25main/lua/LuaInterfaceGame.cpp)  
RES_IRON  
RES_GOLD  
RES_COAL  
RES_GRANITE  
RES_WATER  

## Animals

--> [gameTypes/AnimalTypes.h](../../libs/s25main/gameTypes/AnimalTypes.h)  
SPEC_POLARBEAR  
SPEC_RABBITWHITE  
SPEC_RABBITGREY  
SPEC_FOX  
SPEC_STAG  
SPEC_DEER  
SPEC_DUCK  
SPEC_SHEEP  

## Pact

--> [gameTypes/PactTypes.h](../../libs/s25main/gameTypes/PactTypes.h)  
NON_AGGRESSION_PACT  
TREATY_OF_ALLIANCE  
DURATION_INFINITE
